<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title> sch-rnd developer manual - lihata file formats</title>
<meta http-equiv="Content-Type" content="text/html;charset=us-ascii">
</head>
<body>
<h2> File format root nodes </h2>
<p>Each table below describes the full tree of one of the sch-rnd file formats, from the root.
<h3 id="/lht_tree_doc/roots/cschem-buffer-v*">li:cschem-buffer-v*</h3>
<p>
<table border=0 cellspacing=0>
<tr><th align=left> type:name <th align=left> value <th align=left> <a href="#ver">ver</a> <th align=left> description
<tr id="/lht_tree_doc/roots/cschem-buffer-v*"><td> li:cschem-buffer-v* <td> &nbsp; <td> &nbsp; <td> Buffer content (direct/indirect: same meaning as schematic sheet)
<tr id="/lht_tree_doc/roots/cschem-buffer-v*/children/obj_indirect.1"><td> &nbsp;ha:obj_indirect.1 <td> &nbsp; <td> &nbsp; <td> <a href="#/lht_tree_doc/comm/group.ID"> Group of concrete objects  -&gt; </a>
<tr id="/lht_tree_doc/roots/cschem-buffer-v*/children/obj_direct.2"><td> &nbsp;ha:obj_direct.2 <td> &nbsp; <td> &nbsp; <td> <a href="#/lht_tree_doc/comm/group.ID"> Group of concrete objects  -&gt; </a>
</table>
<h3 id="/lht_tree_doc/roots/sch-rnd-conf-v1">li:sch-rnd-conf-v1</h3>
<p>
<table border=0 cellspacing=0>
<tr><th align=left> type:name <th align=left> value <th align=left> <a href="#ver">ver</a> <th align=left> description
<tr id="/lht_tree_doc/roots/sch-rnd-conf-v1"><td> li:sch-rnd-conf-v1 <td> &nbsp; <td> &nbsp; <td> complete sch-rnd configuration tree
<tr id="/lht_tree_doc/roots/sch-rnd-conf-v1/children/overwrite"><td> &nbsp;ha:overwrite <td> &nbsp; <td> &nbsp; <td> overwrite values while merging; children: a full or partial <a href="../../conf/groups.html#tree">config tree</a>
<tr id="/lht_tree_doc/roots/sch-rnd-conf-v1/children/prepend"><td> &nbsp;ha:prepend <td> &nbsp; <td> &nbsp; <td> prepend values while merging; children: a full or partial <a href="../../conf/groups.html#tree">config tree</a>
<tr id="/lht_tree_doc/roots/sch-rnd-conf-v1/children/append"><td> &nbsp;ha:append <td> &nbsp; <td> &nbsp; <td> append values while merging; children: a full or partial <a href="../../conf/groups.html#tree">config tree</a>
</table>
<h3 id="/lht_tree_doc/roots/std_devmap.v*">ha:std_devmap.v*</h3>
<p>
<table border=0 cellspacing=0>
<tr><th align=left> type:name <th align=left> value <th align=left> <a href="#ver">ver</a> <th align=left> description
<tr id="/lht_tree_doc/roots/std_devmap.v*"><td> ha:std_devmap.v* <td> &nbsp; <td> &nbsp; <td> Device map for plugin std_devmap
<tr id="/lht_tree_doc/roots/std_devmap.v*/children/comp_attribs"><td> &nbsp;ha:comp_attribs <td> &nbsp; <td> &nbsp; <td> Attributes to be set in the abstract component
<tr id="/lht_tree_doc/comm/attrib"><td> &nbsp;&nbsp;ha:attrib <td> &nbsp; <td> &nbsp; <td>  a hash of attributes  
<tr id="/lht_tree_doc/comm/attrib/children/simple-attrib-key"><td> &nbsp;&nbsp;&nbsp;simple-attrib-key <td> <a href="#valtype:string">string</a> <td> &nbsp; <td> attribute value without metadata (text node)
<tr id="/lht_tree_doc/comm/attrib/children/detailed-attrib"><td> &nbsp;&nbsp;&nbsp;ha:detailed-attrib <td> &nbsp; <td> &nbsp; <td>  attribute with metadata (hash node) 
<tr id="/lht_tree_doc/comm/attrib/children/detailed-attrib/children/value"><td> &nbsp;&nbsp;&nbsp;&nbsp;value <td> <a href="#valtype:string">string</a> <td> &nbsp; <td> attribute value
<tr id="/lht_tree_doc/comm/attrib/children/detailed-attrib/children/prio"><td> &nbsp;&nbsp;&nbsp;&nbsp;prio <td> <a href="#valtype:integer">integer</a> <td> &nbsp; <td> priority value
</table>
<h3 id="/lht_tree_doc/roots/cschem-group-v*">li:cschem-group-v*</h3>
<p>
<table border=0 cellspacing=0>
<tr><th align=left> type:name <th align=left> value <th align=left> <a href="#ver">ver</a> <th align=left> description
<tr id="/lht_tree_doc/roots/cschem-group-v*"><td> li:cschem-group-v* <td> &nbsp; <td> &nbsp; <td> concrete group (e.g. symbol) 
<tr id="/lht_tree_doc/roots/cschem-group-v*/children/group.1"><td> &nbsp;ha:group.1 <td> &nbsp; <td> &nbsp; <td> <a href="#/lht_tree_doc/comm/group.ID"> Group of concrete objects  -&gt; </a>
</table>
<h3 id="/lht_tree_doc/roots/cschem-sheet-v*">ha:cschem-sheet-v*</h3>
<p>
<table border=0 cellspacing=0>
<tr><th align=left> type:name <th align=left> value <th align=left> <a href="#ver">ver</a> <th align=left> description
<tr id="/lht_tree_doc/roots/cschem-sheet-v*"><td> ha:cschem-sheet-v* <td> &nbsp; <td> &nbsp; <td> schematic sheet
<tr id="/lht_tree_doc/roots/cschem-sheet-v*/children/obj_indirect.1"><td> &nbsp;ha:obj_indirect.1 <td> &nbsp; <td> &nbsp; <td> <a href="#/lht_tree_doc/comm/group.ID"> Group of concrete objects  -&gt; </a>
<tr id="/lht_tree_doc/roots/cschem-sheet-v*/children/obj_direct.2"><td> &nbsp;ha:obj_direct.2 <td> &nbsp; <td> &nbsp; <td> <a href="#/lht_tree_doc/comm/group.ID"> Group of concrete objects  -&gt; </a>
<tr id="/lht_tree_doc/roots/cschem-sheet-v*/children/conf"><td> &nbsp;li:conf <td> &nbsp; <td> &nbsp; <td> <a href="#/lht_tree_doc/roots/sch-rnd-conf-v1">complete sch-rnd configuration tree -&gt; </a>
</table>
<h2> Common subtrees </h2>
<p>Each table below describes a subtree that usually does not specify a whole tree (thus they are usually not a valid file on their own). These subtrees are described in a separate table because they are used from multiple other trees.
<h3 id="/lht_tree_doc/comm/group.ID">ha:group.ID</h3>
<p>
<table border=0 cellspacing=0>
<tr><th align=left> type:name <th align=left> value <th align=left> <a href="#ver">ver</a> <th align=left> description
<tr id="/lht_tree_doc/comm/group.ID"><td> ha:group.ID <td> &nbsp; <td> &nbsp; <td>  Group of concrete objects 
<tr id="/lht_tree_doc/comm/group.ID/children/uuid"><td> &nbsp;uuid <td> <a href="#valtype:minuid">minuid</a> <td> &nbsp; <td> instance UID 
<tr id="/lht_tree_doc/comm/group.ID/children/src_uuid"><td> &nbsp;src_uuid <td> <a href="#valtype:minuid">minuid</a> <td> &nbsp; <td> source UID 
<tr id="/lht_tree_doc/comm/group.ID/children/x"><td> &nbsp;x <td> <a href="#valtype:coord">coord</a> <td> &nbsp; <td> xform: translate placement in x (horizontal) direction 
<tr id="/lht_tree_doc/comm/group.ID/children/y"><td> &nbsp;y <td> <a href="#valtype:coord">coord</a> <td> &nbsp; <td> xform: translate placement in y (vertical) direction 
<tr id="/lht_tree_doc/comm/group.ID/children/rot"><td> &nbsp;rot <td> <a href="#valtype:angle">angle</a> <td> &nbsp; <td> xform: rotate placement 
<tr id="/lht_tree_doc/comm/group.ID/children/mirx"><td> &nbsp;mirx <td> <a href="#valtype:bool">bool</a> <td> &nbsp; <td> xform: mirror placement left/right 
<tr id="/lht_tree_doc/comm/group.ID/children/miry"><td> &nbsp;miry <td> <a href="#valtype:bool">bool</a> <td> &nbsp; <td> xform: mirror placement child up/down 
<tr id="/lht_tree_doc/comm/group.ID/children/loclib_name"><td> &nbsp;loclib_name <td> <a href="#valtype:string">string</a> <td> &nbsp; <td> name in the local library (optional)
<tr id="/lht_tree_doc/comm/group.ID/children/objects"><td> &nbsp;li:objects <td> &nbsp; <td> &nbsp; <td>  List of child objects 
<tr id="/lht_tree_doc/comm/group.ID/children/objects/children/line.ID"><td> &nbsp;&nbsp;ha:line.ID <td> &nbsp; <td> &nbsp; <td> <a href="#/lht_tree_doc/comm/line.ID"> Drawing object: straight line  -&gt; </a>
<tr id="/lht_tree_doc/comm/group.ID/children/objects/children/arc.ID"><td> &nbsp;&nbsp;ha:arc.ID <td> &nbsp; <td> &nbsp; <td> <a href="#/lht_tree_doc/comm/arc.ID"> Drawing object: circular arc  -&gt; </a>
<tr id="/lht_tree_doc/comm/group.ID/children/objects/children/polygon.ID"><td> &nbsp;&nbsp;ha:polygon.ID <td> &nbsp; <td> &nbsp; <td> <a href="#/lht_tree_doc/comm/polygon.ID"> Drawing object: polygon  -&gt; </a>
<tr id="/lht_tree_doc/comm/group.ID/children/objects/children/text.ID"><td> &nbsp;&nbsp;ha:text.ID <td> &nbsp; <td> &nbsp; <td> <a href="#/lht_tree_doc/comm/text.ID"> Drawing object: straight line  -&gt; </a>
<tr id="/lht_tree_doc/comm/group.ID/children/objects/children/connection.ID"><td> &nbsp;&nbsp;ha:connection.ID <td> &nbsp; <td> &nbsp; <td> <a href="#/lht_tree_doc/comm/connection.ID"> Logical object: connection between different groups  -&gt; </a>
<tr id="/lht_tree_doc/comm/group.ID/children/objects/children/pen.NAME"><td> &nbsp;&nbsp;ha:pen.NAME <td> &nbsp; <td> &nbsp; <td> <a href="#/lht_tree_doc/comm/pen.NAME"> Logical object: a named pen used for drawing; names are unique within a group  -&gt; </a>
<tr id="/lht_tree_doc/comm/attrib"><td> &nbsp;ha:attrib <td> &nbsp; <td> &nbsp; <td>  a hash of attributes  
<tr id="/lht_tree_doc/comm/attrib/children/simple-attrib-key"><td> &nbsp;&nbsp;simple-attrib-key <td> <a href="#valtype:string">string</a> <td> &nbsp; <td> attribute value without metadata (text node)
<tr id="/lht_tree_doc/comm/attrib/children/detailed-attrib"><td> &nbsp;&nbsp;ha:detailed-attrib <td> &nbsp; <td> &nbsp; <td>  attribute with metadata (hash node) 
<tr id="/lht_tree_doc/comm/attrib/children/detailed-attrib/children/value"><td> &nbsp;&nbsp;&nbsp;value <td> <a href="#valtype:string">string</a> <td> &nbsp; <td> attribute value
<tr id="/lht_tree_doc/comm/attrib/children/detailed-attrib/children/prio"><td> &nbsp;&nbsp;&nbsp;prio <td> <a href="#valtype:integer">integer</a> <td> &nbsp; <td> priority value
</table>
<h3 id="/lht_tree_doc/comm/group_ref.ID">ha:group_ref.ID</h3>
<p>
<table border=0 cellspacing=0>
<tr><th align=left> type:name <th align=left> value <th align=left> <a href="#ver">ver</a> <th align=left> description
<tr id="/lht_tree_doc/comm/group_ref.ID"><td> ha:group_ref.ID <td> &nbsp; <td> &nbsp; <td>  Group reference to a concrete object within the same sheet or buffer 
<tr id="/lht_tree_doc/comm/group_ref.ID/children/ref"><td> &nbsp;ref <td> <a href="#valtype:oidpath">oidpath</a> <td> &nbsp; <td> path relative to sheet root, to the referee (should be a group) 
<tr id="/lht_tree_doc/comm/group_ref.ID/children/child_xform"><td> &nbsp;li:child_xform <td> &nbsp; <td> &nbsp; <td>  List of child object transformation to be performed after placement 
<tr id="/lht_tree_doc/comm/group_ref.ID/children/child_xform/children/OIDPATH"><td> &nbsp;&nbsp;OIDPATH <td> &nbsp; <td> &nbsp; <td> list of transformations to be performed on referee children objects after placement; OIDPATH is relative to the referee group 
<tr id="/lht_tree_doc/comm/group_ref.ID/children/child_xform/children/OIDPATH/children/movex"><td> &nbsp;&nbsp;&nbsp;movex <td> <a href="#valtype:coord">coord</a> <td> &nbsp; <td> xform: move child in x (horizontal) direction 
<tr id="/lht_tree_doc/comm/group_ref.ID/children/child_xform/children/OIDPATH/children/movey"><td> &nbsp;&nbsp;&nbsp;movey <td> <a href="#valtype:coord">coord</a> <td> &nbsp; <td> xform: move child in y (vertical) direction 
<tr id="/lht_tree_doc/comm/group_ref.ID/children/child_xform/children/OIDPATH/children/rot"><td> &nbsp;&nbsp;&nbsp;rot <td> <a href="#valtype:angle">angle</a> <td> &nbsp; <td> xform: rotate child 
<tr id="/lht_tree_doc/comm/group_ref.ID/children/child_xform/children/OIDPATH/children/mirx"><td> &nbsp;&nbsp;&nbsp;mirx <td> <a href="#valtype:bool">bool</a> <td> &nbsp; <td> xform: mirror child left/right 
<tr id="/lht_tree_doc/comm/group_ref.ID/children/child_xform/children/OIDPATH/children/miry"><td> &nbsp;&nbsp;&nbsp;miry <td> <a href="#valtype:bool">bool</a> <td> &nbsp; <td> xform: mirror child up/down 
<tr id="/lht_tree_doc/comm/group_ref.ID/children/child_xform/children/OIDPATH/children/remove"><td> &nbsp;&nbsp;&nbsp;remove <td> <a href="#valtype:bool">bool</a> <td> &nbsp; <td> xform: mirror child up/down 
<tr id="/lht_tree_doc/comm/attrib"><td> &nbsp;ha:attrib <td> &nbsp; <td> &nbsp; <td>  a hash of attributes  
<tr id="/lht_tree_doc/comm/attrib/children/simple-attrib-key"><td> &nbsp;&nbsp;simple-attrib-key <td> <a href="#valtype:string">string</a> <td> &nbsp; <td> attribute value without metadata (text node)
<tr id="/lht_tree_doc/comm/attrib/children/detailed-attrib"><td> &nbsp;&nbsp;ha:detailed-attrib <td> &nbsp; <td> &nbsp; <td>  attribute with metadata (hash node) 
<tr id="/lht_tree_doc/comm/attrib/children/detailed-attrib/children/value"><td> &nbsp;&nbsp;&nbsp;value <td> <a href="#valtype:string">string</a> <td> &nbsp; <td> attribute value
<tr id="/lht_tree_doc/comm/attrib/children/detailed-attrib/children/prio"><td> &nbsp;&nbsp;&nbsp;prio <td> <a href="#valtype:integer">integer</a> <td> &nbsp; <td> priority value
</table>
<h3 id="/lht_tree_doc/comm/line.ID">ha:line.ID</h3>
<p>
<table border=0 cellspacing=0>
<tr><th align=left> type:name <th align=left> value <th align=left> <a href="#ver">ver</a> <th align=left> description
<tr id="/lht_tree_doc/comm/line.ID"><td> ha:line.ID <td> &nbsp; <td> &nbsp; <td>  Drawing object: straight line 
<tr id="/lht_tree_doc/comm/line.ID/children/x1"><td> &nbsp;x1 <td> <a href="#valtype:coord">coord</a> <td> &nbsp; <td> start point, x coord 
<tr id="/lht_tree_doc/comm/line.ID/children/y1"><td> &nbsp;y1 <td> <a href="#valtype:coord">coord</a> <td> &nbsp; <td> start point, y coord 
<tr id="/lht_tree_doc/comm/line.ID/children/x2"><td> &nbsp;x2 <td> <a href="#valtype:coord">coord</a> <td> &nbsp; <td> end point, x coord 
<tr id="/lht_tree_doc/comm/line.ID/children/y2"><td> &nbsp;y2 <td> <a href="#valtype:coord">coord</a> <td> &nbsp; <td> end point, y coord 
<tr id="/lht_tree_doc/comm/line.ID/children/stroke"><td> &nbsp;stroke <td> <a href="#valtype:pen">pen</a> <td> &nbsp; <td> pen to use 
<tr id="/lht_tree_doc/comm/line.ID/children/lock"><td> &nbsp;lock <td> <a href="#valtype:bool">bool</a> <td> &nbsp; <td> object is locked 
<tr id="/lht_tree_doc/comm/line.ID/children/floater"><td> &nbsp;floater <td> <a href="#valtype:bool">bool</a> <td> &nbsp; <td> "group lock" doesn't apply 
</table>
<h3 id="/lht_tree_doc/comm/arc.ID">ha:arc.ID</h3>
<p>
<table border=0 cellspacing=0>
<tr><th align=left> type:name <th align=left> value <th align=left> <a href="#ver">ver</a> <th align=left> description
<tr id="/lht_tree_doc/comm/arc.ID"><td> ha:arc.ID <td> &nbsp; <td> &nbsp; <td>  Drawing object: circular arc 
<tr id="/lht_tree_doc/comm/arc.ID/children/cx"><td> &nbsp;cx <td> <a href="#valtype:coord">coord</a> <td> &nbsp; <td> center point, x coord 
<tr id="/lht_tree_doc/comm/arc.ID/children/cy"><td> &nbsp;cy <td> <a href="#valtype:coord">coord</a> <td> &nbsp; <td> center point, y coord 
<tr id="/lht_tree_doc/comm/arc.ID/children/r"><td> &nbsp;r <td> <a href="#valtype:coord">coord</a> <td> &nbsp; <td> radius 
<tr id="/lht_tree_doc/comm/arc.ID/children/sang"><td> &nbsp;sang <td> <a href="#valtype:angle">angle</a> <td> &nbsp; <td> start angle 
<tr id="/lht_tree_doc/comm/arc.ID/children/dang"><td> &nbsp;dang <td> <a href="#valtype:angle">angle</a> <td> &nbsp; <td> delta angle 
<tr id="/lht_tree_doc/comm/arc.ID/children/sx"><td> &nbsp;sx <td> <a href="#valtype:coord">coord</a> <td> &nbsp; <td> start point, x coord 
<tr id="/lht_tree_doc/comm/arc.ID/children/sy"><td> &nbsp;sy <td> <a href="#valtype:coord">coord</a> <td> &nbsp; <td> start point, y coord 
<tr id="/lht_tree_doc/comm/arc.ID/children/ex"><td> &nbsp;ex <td> <a href="#valtype:coord">coord</a> <td> &nbsp; <td> end point, x coord 
<tr id="/lht_tree_doc/comm/arc.ID/children/ey"><td> &nbsp;ey <td> <a href="#valtype:coord">coord</a> <td> &nbsp; <td> end point, y coord 
<tr id="/lht_tree_doc/comm/arc.ID/children/stroke"><td> &nbsp;stroke <td> <a href="#valtype:pen">pen</a> <td> &nbsp; <td> pen to use 
<tr id="/lht_tree_doc/comm/arc.ID/children/lock"><td> &nbsp;lock <td> <a href="#valtype:bool">bool</a> <td> &nbsp; <td> object is locked 
<tr id="/lht_tree_doc/comm/arc.ID/children/floater"><td> &nbsp;floater <td> <a href="#valtype:bool">bool</a> <td> &nbsp; <td> "group lock" doesn't apply 
</table>
<h3 id="/lht_tree_doc/comm/polygon.ID">ha:polygon.ID</h3>
<p>
<table border=0 cellspacing=0>
<tr><th align=left> type:name <th align=left> value <th align=left> <a href="#ver">ver</a> <th align=left> description
<tr id="/lht_tree_doc/comm/polygon.ID"><td> ha:polygon.ID <td> &nbsp; <td> &nbsp; <td>  Drawing object: polygon 
<tr id="/lht_tree_doc/comm/polygon.ID/children/outline"><td> &nbsp;li:outline <td> &nbsp; <td> &nbsp; <td>  ordered list of contour objects (no gaps allowed) 
<tr id="/lht_tree_doc/comm/polygon.ID/children/outline/children/line.ID"><td> &nbsp;&nbsp;ha:line.ID <td> &nbsp; <td> &nbsp; <td> <a href="#/lht_tree_doc/comm/line.ID"> Drawing object: straight line  -&gt; </a>
<tr id="/lht_tree_doc/comm/polygon.ID/children/outline/children/arc.ID"><td> &nbsp;&nbsp;ha:arc.ID <td> &nbsp; <td> &nbsp; <td> <a href="#/lht_tree_doc/comm/arc.ID"> Drawing object: circular arc  -&gt; </a>
<tr id="/lht_tree_doc/comm/polygon.ID/children/stroke"><td> &nbsp;stroke <td> <a href="#valtype:pen">pen</a> <td> &nbsp; <td> pen used for outline objects 
<tr id="/lht_tree_doc/comm/polygon.ID/children/fill"><td> &nbsp;fill <td> <a href="#valtype:pen">pen</a> <td> &nbsp; <td> pen used for fill (no fill if not present)
<tr id="/lht_tree_doc/comm/polygon.ID/children/lock"><td> &nbsp;lock <td> <a href="#valtype:bool">bool</a> <td> &nbsp; <td> object is locked 
<tr id="/lht_tree_doc/comm/polygon.ID/children/floater"><td> &nbsp;floater <td> <a href="#valtype:bool">bool</a> <td> &nbsp; <td> "group lock" doesn't apply 
</table>
<h3 id="/lht_tree_doc/comm/connection.ID">ha:connection.ID</h3>
<p>
<table border=0 cellspacing=0>
<tr><th align=left> type:name <th align=left> value <th align=left> <a href="#ver">ver</a> <th align=left> description
<tr id="/lht_tree_doc/comm/connection.ID"><td> ha:connection.ID <td> &nbsp; <td> &nbsp; <td>  Logical object: connection between different groups 
<tr id="/lht_tree_doc/comm/connection.ID/children/conn"><td> &nbsp;li:conn <td> &nbsp; <td> &nbsp; <td>  list of objects participating in the connection (at least 2)
<tr id="/lht_tree_doc/comm/connection.ID/children/conn/children/OIDPATH"><td> &nbsp;&nbsp;OIDPATH <td> <a href="#valtype:oidpath">oidpath</a> <td> &nbsp; <td> drawing object making the connection )
</table>
<h3 id="/lht_tree_doc/comm/text.ID">ha:text.ID</h3>
<p>
<table border=0 cellspacing=0>
<tr><th align=left> type:name <th align=left> value <th align=left> <a href="#ver">ver</a> <th align=left> description
<tr id="/lht_tree_doc/comm/text.ID"><td> ha:text.ID <td> &nbsp; <td> &nbsp; <td>  Drawing object: straight line 
<tr id="/lht_tree_doc/comm/text.ID/children/text"><td> &nbsp;text <td> <a href="#valtype:string">string</a> <td> &nbsp; <td> text string (or dyntext template)
<tr id="/lht_tree_doc/comm/text.ID/children/x1"><td> &nbsp;x1 <td> <a href="#valtype:coord">coord</a> <td> &nbsp; <td> lower left x coord of text box 
<tr id="/lht_tree_doc/comm/text.ID/children/y1"><td> &nbsp;y1 <td> <a href="#valtype:coord">coord</a> <td> &nbsp; <td> lower left y coord of text box 
<tr id="/lht_tree_doc/comm/text.ID/children/x2"><td> &nbsp;x2 <td> <a href="#valtype:coord">coord</a> <td> &nbsp; <td> upper right corner of untrasformed box; present only if text size is bbox-specified 
<tr id="/lht_tree_doc/comm/text.ID/children/y2"><td> &nbsp;y2 <td> <a href="#valtype:coord">coord</a> <td> &nbsp; <td> upper right corner of untrasformed box; present only if text size is bbox-specified 
<tr id="/lht_tree_doc/comm/text.ID/children/rot"><td> &nbsp;rot <td> <a href="#valtype:angle">angle</a> <td> &nbsp; <td> rotaition around x1;y1 
<tr id="/lht_tree_doc/comm/text.ID/children/mirx"><td> &nbsp;mirx <td> <a href="#valtype:bool">bool</a> <td> &nbsp; <td> mirror origin/bbox left/right
<tr id="/lht_tree_doc/comm/text.ID/children/miry"><td> &nbsp;miry <td> <a href="#valtype:bool">bool</a> <td> &nbsp; <td> mirror origin/bbox up/down
<tr id="/lht_tree_doc/comm/text.ID/children/halign"><td> &nbsp;halign <td> <a href="#valtype:halign">halign</a> <td> &nbsp; <td> horizontal alignment 
<tr id="/lht_tree_doc/comm/text.ID/children/dyntext"><td> &nbsp;dyntext <td> <a href="#valtype:bool">bool</a> <td> &nbsp; <td> if text string is a dyntext template 
<tr id="/lht_tree_doc/comm/text.ID/children/stroke"><td> &nbsp;stroke <td> <a href="#valtype:pen">pen</a> <td> &nbsp; <td> pen to use 
<tr id="/lht_tree_doc/comm/text.ID/children/lock"><td> &nbsp;lock <td> <a href="#valtype:bool">bool</a> <td> &nbsp; <td> object is locked 
<tr id="/lht_tree_doc/comm/text.ID/children/floater"><td> &nbsp;floater <td> <a href="#valtype:bool">bool</a> <td> &nbsp; <td> "group lock" doesn't apply 
</table>
<h3 id="/lht_tree_doc/comm/pen.NAME">ha:pen.NAME</h3>
<p>
<table border=0 cellspacing=0>
<tr><th align=left> type:name <th align=left> value <th align=left> <a href="#ver">ver</a> <th align=left> description
<tr id="/lht_tree_doc/comm/pen.NAME"><td> ha:pen.NAME <td> &nbsp; <td> &nbsp; <td>  Logical object: a named pen used for drawing; names are unique within a group 
<tr id="/lht_tree_doc/comm/pen.NAME/children/shape"><td> &nbsp;shape <td> <a href="#valtype:shape">shape</a> <td> &nbsp; <td> pen tip shape)
<tr id="/lht_tree_doc/comm/pen.NAME/children/size"><td> &nbsp;size <td> <a href="#valtype:coord">coord</a> <td> &nbsp; <td> diameter or side length
<tr id="/lht_tree_doc/comm/pen.NAME/children/color"><td> &nbsp;color <td> <a href="#valtype:color">color</a> <td> &nbsp; <td> ink color 
<tr id="/lht_tree_doc/comm/pen.NAME/children/font_height"><td> &nbsp;font_height <td> <a href="#valtype:coord">coord</a> <td> &nbsp; <td> height of text font for non-bbox-defined text
<tr id="/lht_tree_doc/comm/pen.NAME/children/font_family"><td> &nbsp;font_family <td> <a href="#valtype:string">string</a> <td> &nbsp; <td> family hint for the font selector
<tr id="/lht_tree_doc/comm/pen.NAME/children/font_style"><td> &nbsp;font_style <td> <a href="#valtype:string">string</a> <td> &nbsp; <td> style hint for the font selector
<tr id="/lht_tree_doc/comm/pen.NAME/children/dash"><td> &nbsp;dash <td> <a href="#valtype:hex4">hex4</a> <td> &nbsp; <td> dash pattern 
<tr id="/lht_tree_doc/comm/pen.NAME/children/dash_period"><td> &nbsp;dash_period <td> <a href="#valtype:coord">coord</a> <td> &nbsp; <td> dash pattern length
</table>
<h2 id="types"> Types </h2>
<p>
<table border=1 width=700>
<tr><th> type <th> description
<tr id="valtype:angle">
	<td>angle
	<td>
 A decimal number without unit, representing an angle in degree. Can
 be positive or negative.

<tr id="valtype:coord">
	<td>coord
	<td>
 A decimal integer.

<tr id="valtype:double">
	<td>double
	<td>
 Unitless numeric value in decimal format. Depending on context it is
 sometimes signed.

<tr id="valtype:integer">
	<td>integer
	<td>
 Unitless integer value in decimal format. Depending on context it is
 sometimes signed.

<tr id="valtype:hex4">
	<td>hex4
	<td>
 4 digits of hexadecimal numbers (0-9, a-f, A-F)

<tr id="valtype:bool">
	<td>bool
	<td>
 Single digit boolean value: 0 means false, 1 means true.

<tr id="valtype:pen">
	<td>pen
	<td>
 Name of a pen defined in a parent group.

<tr id="valtype:halign">
	<td>halign
	<td>
 One of: left, center, right, word_justify, justify.

<tr id="valtype:shape">
	<td>shape
	<td>
 One of: round, square.

<tr id="valtype:color">
	<td>color
	<td>
 #rrggbb

<tr id="valtype:minuid">
	<td>minuid
	<td>
 An unique ID as generated by libminuid (24 ASCII characters).

<tr id="valtype:none">
	<td>none
	<td>
 No value.

<tr id="valtype:string">
	<td>string
	<td>
 Free form text data

<tr id="valtype:oidpath">
	<td>oidpath
	<td>
 A slash separated list of integer object IDs (oids).

</table>
<h2> Comments </h2>
<p id="ver">ver column: <a href="../io_lihata_ver.html">Format version</a> range the subtree may appear in.
</body>
</html>
